



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>自定义view实现水波纹效果</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">自定义view实现水波纹效果</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 08:57:19 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<h3>水波纹效果：</h3>
<p>1.标准正余弦水波纹； <br /><br />
2.非标准圆形液柱水波纹； <br /><br />
虽说都是水波纹，但两者在实现上差异是比较大的，一个通过正余弦函数模拟水波纹效果，另外一个会运用到图像的混合模式（PorterDuffXfermode）；</p>
<p>先看效果：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150322171015673?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvdGlhbmppYW40NTky/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"></p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150322171037482?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvdGlhbmppYW40NTky/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"></p>
<p>自定义View根据实际情况可以选择继承自View、TextView、ImageView或其他 <br /><br />
这次的实现我们都选择继承view，在实现的过程中我们需要关注如下几个方法： <br /><br />
1.onMeasure():最先回调，用于控件的测量; <br /><br />
2.onSizeChanged():在onMeasure后面回调，可以拿到view的宽高等数据，在横竖屏切换时也会回调; <br /><br />
3.onDraw()：真正的绘制部分，绘制的代码都写到这里面;</p>
<p>既然如此，我们先复写这三个方法，然后来实现如上两个效果；</p>
<h3>一：标准正余弦水波纹</h3>
<p>这种水波纹可以用具体函数模拟出具体的轨迹，所以思路基本如下： <br /><br />
1.确定水波函数方程 <br /><br />
2.根据函数方程得出每一个波纹上点的坐标； <br /><br />
3.将水波进行平移，即将水波上的点不断的移动； <br /><br />
4.不断的重新绘制，生成动态水波纹； <br /><br />
有了上面的思路，我们一步一步进行实现：</p>
<p>正余弦函数方程为： <br /><br />
y = Asin(wx+b)+h ，这个公式里：w影响周期，A影响振幅，h影响y位置，b为初相；</p>
<p>根据上面的方程选取自己觉得中意的波纹效果，确定对应参数的取值； <br /><br />
然后根据确定好的方程得出所有的方程上y的数值，并将所有y值保存在数组里：</p>
<pre class="prettyprint linenums"><code>// 将周期定为view总宽度<br />
mCycleFactorW = (float) (2 * Math.PI / mTotalWidth);  

// 根据view总宽度得出所有对应的y值<br />
for (int i = 0; i &lt; mTotalWidth; i++) {<br />
    mYPositions[i] = (float) (STRETCH_FACTOR_A * Math.sin(mCycleFactorW * i) + OFFSET_Y);<br />
}  </code></pre>
<p>根据得出的所有y值，则可以在onDraw中通过如下代码绘制两条静态波纹：</p>
<pre class="prettyprint linenums"><code>for (int i = 0; i &lt; mTotalWidth; i++) {  

      // 减400只是为了控制波纹绘制的y的在屏幕的位置，大家可以改成一个变量，然后动态改变这个变量，从而形成波纹上升下降效果<br />
      // 绘制第一条水波纹<br />
      canvas.drawLine(i, mTotalHeight - mResetOneYPositions[i] - 400, i,<br />
              mTotalHeight,<br />
              mWavePaint);  

      // 绘制第二条水波纹<br />
      canvas.drawLine(i, mTotalHeight - mResetTwoYPositions[i] - 400, i,<br />
              mTotalHeight,<br />
              mWavePaint);<br />
  }  </code></pre>
<p>这种方式类似于数学里面的细分法，一条波纹，如果横向以一个像素点为单位进行细分，则形成view总宽度条直线，并且每条直线的起点和终点我们都能知道，在此基础上我们只需要循环绘制出所有细分出来的直线（直线都是纵向的），则形成了一条静态的水波纹；</p>
<p>接下来我们让水波纹动起来，之前用了一个数组保存了所有的y值点，有两条水波纹，再利用两个同样大小的数组来保存两条波纹的y值数据，并不断的去改变这两个数组中的数据：</p>
<pre class="prettyprint linenums"><code> private void resetPositonY() {<br />
    // mXOneOffset代表当前第一条水波纹要移动的距离<br />
    int yOneInterval = mYPositions.length - mXOneOffset;<br />
    // 使用System.arraycopy方式重新填充第一条波纹的数据<br />
    System.arraycopy(mYPositions, mXOneOffset, mResetOneYPositions, 0, yOneInterval);<br />
    System.arraycopy(mYPositions, 0, mResetOneYPositions, yOneInterval, mXOneOffset);  

    int yTwoInterval = mYPositions.length - mXTwoOffset;<br />
    System.arraycopy(mYPositions, mXTwoOffset, mResetTwoYPositions, 0,<br />
            yTwoInterval);<br />
    System.arraycopy(mYPositions, 0, mResetTwoYPositions, yTwoInterval, mXTwoOffset);<br />
}  </code></pre>
<p>如此下来只要不断的改变这两个数组的数据，然后不断刷新，即可生成动态水波纹了； <br /><br />
刷新可以调用invalidate()或postInvalidate()，区别在于后者可以在子线程中更新UI</p>
<p>整体代码如下：</p>
<pre class="prettyprint linenums"><code><br />
package com.csdn.csdnblog2.ui;

import com.csdn.csdnblog2.utils.UiUtils;

import android.content.Context;<br />
import android.graphics.Canvas;<br />
import android.graphics.DrawFilter;<br />
import android.graphics.Paint;<br />
import android.graphics.Paint.Style;<br />
import android.graphics.PaintFlagsDrawFilter;<br />
import android.util.AttributeSet;<br />
import android.view.View;

public class DynamicWave extends View {

    // 波纹颜色<br />
    private static final int WAVE_PAINT_COLOR = 0x880000aa;<br />
    // y = Asin(wx+b)+h<br />
    private static final float STRETCH_FACTOR_A = 20;<br />
    private static final int OFFSET_Y = 0;<br />
    // 第一条水波移动速度<br />
    private static final int TRANSLATE_X_SPEED_ONE = 7;<br />
    // 第二条水波移动速度<br />
    private static final int TRANSLATE_X_SPEED_TWO = 5;<br />
    private float mCycleFactorW;

    private int mTotalWidth, mTotalHeight;<br />
    private float[] mYPositions;<br />
    private float[] mResetOneYPositions;<br />
    private float[] mResetTwoYPositions;<br />
    private int mXOffsetSpeedOne;<br />
    private int mXOffsetSpeedTwo;<br />
    private int mXOneOffset;<br />
    private int mXTwoOffset;

    private Paint mWavePaint;<br />
    private DrawFilter mDrawFilter;

    public DynamicWave(Context context, AttributeSet attrs) {<br />
        super(context, attrs);<br />
        // 将dp转化为px，用于控制不同分辨率上移动速度基本一致<br />
        mXOffsetSpeedOne = UiUtils.dipToPx(context, TRANSLATE_X_SPEED_ONE);<br />
        mXOffsetSpeedTwo = UiUtils.dipToPx(context, TRANSLATE_X_SPEED_TWO);

        // 初始绘制波纹的画笔<br />
        mWavePaint = new Paint();<br />
        // 去除画笔锯齿<br />
        mWavePaint.setAntiAlias(true);<br />
        // 设置风格为实线<br />
        mWavePaint.setStyle(Style.FILL);<br />
        // 设置画笔颜色<br />
        mWavePaint.setColor(WAVE_PAINT_COLOR);<br />
        mDrawFilter = new PaintFlagsDrawFilter(0, Paint.ANTI_ALIAS_FLAG | Paint.FILTER_BITMAP_FLAG);<br />
    }

    @Override<br />
    protected void onDraw(Canvas canvas) {<br />
        super.onDraw(canvas);<br />
        // 从canvas层面去除绘制时锯齿<br />
        canvas.setDrawFilter(mDrawFilter);<br />
        resetPositonY();<br />
        for (int i = 0; i &lt; mTotalWidth; i++) {

            // 减400只是为了控制波纹绘制的y的在屏幕的位置，大家可以改成一个变量，然后动态改变这个变量，从而形成波纹上升下降效果<br />
            // 绘制第一条水波纹<br />
            canvas.drawLine(i, mTotalHeight - mResetOneYPositions[i] - 400, i,<br />
                    mTotalHeight,<br />
                    mWavePaint);

            // 绘制第二条水波纹<br />
            canvas.drawLine(i, mTotalHeight - mResetTwoYPositions[i] - 400, i,<br />
                    mTotalHeight,<br />
                    mWavePaint);<br />
        }

        // 改变两条波纹的移动点<br />
        mXOneOffset += mXOffsetSpeedOne;<br />
        mXTwoOffset += mXOffsetSpeedTwo;

        // 如果已经移动到结尾处，则重头记录<br />
        if (mXOneOffset &gt;= mTotalWidth) {<br />
            mXOneOffset = 0;<br />
        }<br />
        if (mXTwoOffset &gt; mTotalWidth) {<br />
            mXTwoOffset = 0;<br />
        }

        // 引发view重绘，一般可以考虑延迟20-30ms重绘，空出时间片<br />
        postInvalidate();<br />
    }

    private void resetPositonY() {<br />
        // mXOneOffset代表当前第一条水波纹要移动的距离<br />
        int yOneInterval = mYPositions.length - mXOneOffset;<br />
        // 使用System.arraycopy方式重新填充第一条波纹的数据<br />
        System.arraycopy(mYPositions, mXOneOffset, mResetOneYPositions, 0, yOneInterval);<br />
        System.arraycopy(mYPositions, 0, mResetOneYPositions, yOneInterval, mXOneOffset);

        int yTwoInterval = mYPositions.length - mXTwoOffset;<br />
        System.arraycopy(mYPositions, mXTwoOffset, mResetTwoYPositions, 0,<br />
                yTwoInterval);<br />
        System.arraycopy(mYPositions, 0, mResetTwoYPositions, yTwoInterval, mXTwoOffset);<br />
    }

    @Override<br />
    protected void onSizeChanged(int w, int h, int oldw, int oldh) {<br />
        super.onSizeChanged(w, h, oldw, oldh);<br />
        // 记录下view的宽高<br />
        mTotalWidth = w;<br />
        mTotalHeight = h;<br />
        // 用于保存原始波纹的y值<br />
        mYPositions = new float[mTotalWidth];<br />
        // 用于保存波纹一的y值<br />
        mResetOneYPositions = new float[mTotalWidth];<br />
        // 用于保存波纹二的y值<br />
        mResetTwoYPositions = new float[mTotalWidth];

        // 将周期定为view总宽度<br />
        mCycleFactorW = (float) (2 * Math.PI / mTotalWidth);

        // 根据view总宽度得出所有对应的y值<br />
        for (int i = 0; i &lt; mTotalWidth; i++) {<br />
            mYPositions[i] = (float) (STRETCH_FACTOR_A * Math.sin(mCycleFactorW * i) + OFFSET_Y);<br />
        }<br />
    }

}</code></pre>
<h3>二：非标准圆形液柱水波纹</h3>
<p>前面的波形使用函数模拟，这个我们换种方式，采用图进行实现，先用PS整张不像波纹的波纹图；</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150312203309359?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvdGlhbmppYW40NTky/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"></p>
<p>为了衔接紧密，首尾都比较平，并高度一致； <br /><br />
思路： <br /><br />
1.使用一个圆形图作为遮罩过滤波形图； <br /><br />
2.平移波纹图，即不断改变绘制的波纹图的区域，即srcRect； <br /><br />
3.当一个周期绘制完，则从波纹图的最前面重新计算；</p>
<p>首先初始化bitmap：</p>
<pre class="prettyprint linenums"><code>private void initBitmap() {<br />
        mSrcBitmap = ((BitmapDrawable) getResources().getDrawable(R.drawable.wave_2000))<br />
                .getBitmap();<br />
        mMaskBitmap = ((BitmapDrawable) getResources().getDrawable(<br />
                R.drawable.circle_500))<br />
                .getBitmap();<br />
    }  </code></pre>
<p>使用drawable获取的方式，全局只会生成一份，并且系统会进行管理，而BitmapFactory.decode()出来的则decode多少次生成多少张，务必自己进行recycle；</p>
<p>然后绘制波浪和遮罩图，绘制时设置对应的混合模式：</p>
<pre class="prettyprint linenums"><code>/*<br />
 * 将绘制操作保存到新的图层<br />
 */<br />
int sc = canvas.saveLayer(0, 0, mTotalWidth, mTotalHeight, null, Canvas.ALL_SAVE_FLAG);  

// 设定要绘制的波纹部分<br />
mSrcRect.set(mCurrentPosition, 0, mCurrentPosition + mCenterX, mTotalHeight);<br />
// 绘制波纹部分<br />
canvas.drawBitmap(mSrcBitmap, mSrcRect, mDestRect, mBitmapPaint);  

// 设置图像的混合模式<br />
mBitmapPaint.setXfermode(mPorterDuffXfermode);<br />
// 绘制遮罩圆<br />
canvas.drawBitmap(mMaskBitmap, mMaskSrcRect, mMaskDestRect,<br />
        mBitmapPaint);<br />
mBitmapPaint.setXfermode(null);<br />
canvas.restoreToCount(sc);<br />
</code></pre>
<p>为了形成动态的波浪效果，单开一个线程动态更新要绘制的波浪的位置：</p>
<pre class="prettyprint linenums"><code>new Thread() {<br />
    public void run() {<br />
        while (true) {<br />
            // 不断改变绘制的波浪的位置<br />
            mCurrentPosition += mSpeed;<br />
            if (mCurrentPosition &gt;= mSrcBitmap.getWidth()) {<br />
                mCurrentPosition = 0;<br />
            }<br />
            try {<br />
                // 为了保证效果的同时，尽可能将cpu空出来，供其他部分使用<br />
                Thread.sleep(30);<br />
            } catch (InterruptedException e) {<br />
            }  

            postInvalidate();<br />
        }  

    };<br />
}.start();  </code></pre>
<h3>全部代码如下</h3>
<pre class="prettyprint linenums"><code><br />
package com.csdn.csdnblog2.ui;

import android.content.Context;<br />
import android.graphics.Bitmap;<br />
import android.graphics.Canvas;<br />
import android.graphics.Color;<br />
import android.graphics.Paint;<br />
import android.graphics.PaintFlagsDrawFilter;<br />
import android.graphics.PorterDuff;<br />
import android.graphics.PorterDuffXfermode;<br />
import android.graphics.Rect;<br />
import android.graphics.drawable.BitmapDrawable;<br />
import android.util.AttributeSet;<br />
import android.view.View;

import com.csdn.csdnblog2.R;<br />
import com.csdn.csdnblog2.utils.UiUtils;

/**<br />
 * @author tianjian<br />
 * @created 2015/2/2<br />
 */<br />
public class PorterDuffXfermodeView extends View {

    private static final int WAVE_TRANS_SPEED = 4;

    private Paint mBitmapPaint, mPicPaint;<br />
    private int mTotalWidth, mTotalHeight;<br />
    private int mCenterX, mCenterY;<br />
    private int mSpeed;

    private Bitmap mSrcBitmap;<br />
    private Rect mSrcRect, mDestRect;

    private PorterDuffXfermode mPorterDuffXfermode;<br />
    private Bitmap mMaskBitmap;<br />
    private Rect mMaskSrcRect, mMaskDestRect;<br />
    private PaintFlagsDrawFilter mDrawFilter;

    private int mCurrentPosition;

    public PorterDuffXfermodeView(Context context, AttributeSet attrs) {<br />
        super(context, attrs);<br />
        initPaint();<br />
        initBitmap();<br />
        mPorterDuffXfermode = new PorterDuffXfermode(PorterDuff.Mode.DST_IN);<br />
        mSpeed = UiUtils.dipToPx(getContext(), WAVE_TRANS_SPEED);<br />
        mDrawFilter = new PaintFlagsDrawFilter(Paint.ANTI_ALIAS_FLAG, Paint.DITHER_FLAG);<br />
        new Thread() {<br />
            public void run() {<br />
                while (true) {<br />
                    // 不断改变绘制的波浪的位置<br />
                    mCurrentPosition += mSpeed;<br />
                    if (mCurrentPosition &gt;= mSrcBitmap.getWidth()) {<br />
                        mCurrentPosition = 0;<br />
                    }<br />
                    try {<br />
                        // 为了保证效果的同时，尽可能将cpu空出来，供其他部分使用<br />
                        Thread.sleep(30);<br />
                    } catch (InterruptedException e) {<br />
                    }

                    postInvalidate();<br />
                }

            };<br />
        }.start();<br />
    }

    @Override<br />
    protected void onDraw(Canvas canvas) {<br />
        super.onDraw(canvas);

        // 从canvas层面去除锯齿<br />
        canvas.setDrawFilter(mDrawFilter);<br />
        canvas.drawColor(Color.TRANSPARENT);

        /*<br />
         * 将绘制操作保存到新的图层<br />
         */<br />
        int sc = canvas.saveLayer(0, 0, mTotalWidth, mTotalHeight, null, Canvas.ALL_SAVE_FLAG);

        // 设定要绘制的波纹部分<br />
        mSrcRect.set(mCurrentPosition, 0, mCurrentPosition + mCenterX, mTotalHeight);<br />
        // 绘制波纹部分<br />
        canvas.drawBitmap(mSrcBitmap, mSrcRect, mDestRect, mBitmapPaint);

        // 设置图像的混合模式<br />
        mBitmapPaint.setXfermode(mPorterDuffXfermode);<br />
        // 绘制遮罩圆<br />
        canvas.drawBitmap(mMaskBitmap, mMaskSrcRect, mMaskDestRect,<br />
                mBitmapPaint);<br />
        mBitmapPaint.setXfermode(null);<br />
        canvas.restoreToCount(sc);<br />
    }

    // 初始化bitmap<br />
    private void initBitmap() {<br />
        mSrcBitmap = ((BitmapDrawable) getResources().getDrawable(R.drawable.wave_2000))<br />
                .getBitmap();<br />
        mMaskBitmap = ((BitmapDrawable) getResources().getDrawable(<br />
                R.drawable.circle_500))<br />
                .getBitmap();<br />
    }

    // 初始化画笔paint<br />
    private void initPaint() {

        mBitmapPaint = new Paint();<br />
        // 防抖动<br />
        mBitmapPaint.setDither(true);<br />
        // 开启图像过滤<br />
        mBitmapPaint.setFilterBitmap(true);

        mPicPaint = new Paint(Paint.ANTI_ALIAS_FLAG);<br />
        mPicPaint.setDither(true);<br />
        mPicPaint.setColor(Color.RED);<br />
    }

    @Override<br />
    protected void onSizeChanged(int w, int h, int oldw, int oldh) {<br />
        super.onSizeChanged(w, h, oldw, oldh);<br />
        mTotalWidth = w;<br />
        mTotalHeight = h;<br />
        mCenterX = mTotalWidth / 2;<br />
        mCenterY = mTotalHeight / 2;

        mSrcRect = new Rect();<br />
        mDestRect = new Rect(0, 0, mTotalWidth, mTotalHeight);

        int maskWidth = mMaskBitmap.getWidth();<br />
        int maskHeight = mMaskBitmap.getHeight();<br />
        mMaskSrcRect = new Rect(0, 0, maskWidth, maskHeight);<br />
        mMaskDestRect = new Rect(0, 0, mTotalWidth, mTotalHeight);<br />
    }

}</code></pre>
<h3>一些知识点</h3>
<ul><li><p>canvas.saveLayer <br /><br />
参考链接 <a href="http://blog.csdn.net/linghu_java/article/details/8939952" rel="external nofollow noreferrer">Android中的canvas介绍 - linghu_java的专栏 - 博客频道 - CSDN.NET</a></p></li>
<li><p>android中Canvas使用drawBitmap绘制图片 <br /><br />
参考链接  <a href="http://blog.csdn.net/longyi_java/article/details/6930480" rel="external nofollow noreferrer">android中Canvas使用drawBitmap绘制图片 - longyi_java的专栏 - 博客频道 - CSDN.NET</a></p></li>
<li><p>canvas.setXfermode属性 <br /><br />
参考链接:<a href="http://407827531.iteye.com/blog/1470519" rel="external nofollow noreferrer">setXfermode属性 - xSTARx - ITeye技术网站</a></p></li></ul>
<h3>源代码</h3>
<p><a href="http://download.csdn.net/detail/tianjian4592/8571345" rel="external nofollow noreferrer">源代码</a></p>
<h3>参考链接</h3>
<p><a href="http://blog.csdn.net/tianjian4592/article/details/44222565" rel="external nofollow noreferrer">自定义view实现水波纹效果 - Ajian_studio - 博客频道 - CSDN.NET</a></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7g6okq.html">给flash添加A链接</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oyve5q.html">Servlet--表单、超链接、转发、重定向4种情况的路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/4956dee8.html">转MYSQL学习（四） 查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdekzvz9.html">php环境配置中各个模块在网站建设中的功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xevlm8.html">Ubuntu 修改时区和时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz4jjl8.html">11&period;1、Libgdx的音频之音效</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllj076q.html">PEP8 规范</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25ejvoq.html">Srorm并发机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2w21o9.html">Git 学习笔记--删除错误提交的commit</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvz0dj8.html">MyEclipse配置默认自带的HTML&sol;JSP代码格式化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyymxdgq.html">c&plus;&plus; 面试题（汇总）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjmvzr8.html">AngularJS 的异步服务测试与Mocking</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjl6wr8.html">chromedriver下载安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjx2yp8.html">【刷题】洛谷 P1519 穿越栅栏 Overfencing</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k1rp3q.html">SharePoint 2013的100个新功能之开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn2dddq.html">切图，css注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4m5mpq.html">python根据正则表达式的简单爬虫</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwodw1z9.html">一个查看Cookie的便捷工具&mdash;&mdash;EditThisCookie</a>
		</li>
						<li><a href="https://www.batexi.com/a/q444k3eq.html">BZOJ 2115 Xor&lpar;线性基&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8od3wylq.html">组合数取模介绍----Lucas定理介绍</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/5qxp1wz9.html">JDBCTemplate基础学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/49546peq.html">vc&plus;&plus; 6&period;0下Glut的配置 及 Glut 框架介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/49546n6q.html">Circular Sequence，ＡCM&sol;ICPC Seoul 2004&comma;UVa 1584</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv6gpo8.html">兼容amd&comma;commonjs和browser的模块写法</a>
			</li>
						<li><a href="https://www.batexi.com/a/49glm34q.html">glibc 简介：</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kw1vj8.html">（三）Linux命令基本格式以及文件处理命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pzjrk8.html">thinkphp 3&period;23 第三方登录sdk集成包</a>
			</li>
						<li><a href="https://www.batexi.com/a/m961pe38.html">thinkphp中where方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o71d5q.html">A&plus;B Again（在某个数中找大于m的最小约数）</a>
			</li>
						<li><a href="https://www.batexi.com/a/4956gpz8.html">Rescue</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
